package danielcortes.xyz;

import danielcortes.xyz.controllers.BaseLayoutController;
import danielcortes.xyz.data.Configuration;
import danielcortes.xyz.data.DAOManager;
import danielcortes.xyz.views.BaseLayout;
import java.util.Locale;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

public class Main {

  private static final int DATABASE_VERSION = 3;
  private static final String VERSION = "1.0";

  static {
    setUpSystemProperties();
    DAOManager.setup();
    updateDatabase();
  }

  public static void main(String[] args) {
    System.out.println("--------------------------------------------------------------------------------");
    System.out.println("Software version: " + VERSION);
    System.out.println("Database version: " + DATABASE_VERSION);
    System.out.println("--------------------------------------------------------------------------------");
    run();
  }

  private static void run() {
    BaseLayout view = new BaseLayout();
    BaseLayoutController controller = new BaseLayoutController(view);
    executeView(view.getContentPanel());
  }

  private static void updateDatabase() {
    DAOManager.getVersionDAO().updateTo(DATABASE_VERSION);
  }

  private static void executeView(JComponent view) {
    JFrame frame = new JFrame(Configuration.get("nombre_caja"));
    frame.setContentPane(view);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    frame.pack();
    frame.setLocationRelativeTo(null);
    frame.setVisible(true);
  }

  private static void setUpSystemProperties() {
    System.setProperty("awt.useSystemAAFontSettings", "on");
    System.setProperty("swing.aatext", "true");

    try {
      UIManager.setLookAndFeel(Configuration.get("look_and_feel"));
    } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException e) {
      e.printStackTrace();
    }

    Locale.setDefault(new Locale("es"));
  }
}
